<!DOCTYPE html>
<html lang="en">

<head>
    <title>task 41.55 Filter Users</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
    <!-- Import Datatable sau jquery -->
    <!-- Import them style bootstrap cho datatable -->
    <link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css">
    <script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
    <script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>

</head>

<body>
    <div class="container">
        <h2 style="text-align: center;">Danh sách đăng ký</h2>
        <div class="container jumbotron p-7">
            <div class="row form-group">
                <label for="input-firstname" class="col-sm-2 col-form-label">Trạng thái Order</label>
                <div class="col-sm-3">
                    <select class="form-control" name="" id="sel-status">
                        <option value="all">All</option>
                        <option value="open">Open</option>
                        <option value="confirmed">Confirmed</option>
                        <option value="cancel">Cancel</option>

                    </select>
                </div>
                <label for="input-lastname" class="col-sm-2 col-form-label">Loại pizza</label>
                <div class="col-sm-3">
                    <select class="form-control" name="" id="sel-pizza">
                        <option value="all">All</option>
                        <option value="hawai">Hawai</option>
                        <option value="bacon">Bacon</option>
                        <option value="seafood">Seafood</option>
                    </select>
                </div>
                <div class="col-sm-2">
                    <button class="btn btn-info" id="btn-filter-users">Lọc</button>
                </div>
            </div>
        </div>
        <table class="table table-bordered table-striped table-hover" id="order-table">
            <thead>
                <tr>
                    <th>Order Code</th>
                    <th>Kích cỡ Compo</th>
                    <th>Loại Pizza</th>
                    <th>Nước Uống</th>
                    <th>Thành Tiền</th>
                    <th>Họ và Tên</th>
                    <th>Số điện thoại </th>
                    <th>Trạng Thái</th>
                    <th>Action</th>
                </tr>
        </table>
    </div>
</body>
<script>
    $(document).ready(function () {
        /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
        var gDataUser = []
        const gBASE_URL = "http://203.171.20.210:8080/devcamp-pizza365/orders";

        const gCOLUMN_ORDER_CODE = 0;
        const gCOLUMN_KICHCO = 1;
        const gCOLUMN_LOAI_PIZZA = 2;
        const gCOLUMN_NUOCUONG = 3;
        const gCOLUMN_THANHTIEN = 4;
        const gCOLUMN_HOTEN = 5;
        const gCOLUMN_SDT = 6;
        const gCOLUMN_TRANG_THAI = 7;
        const gCOLUMN_ACTION = 8;
        const gORDER = ["orderCode", "kichCo", "loaiPizza", "idLoaiNuocUong", "thanhTien", "hoTen", "soDienThoai", "trangThai", "action"];

        $("#order-table").DataTable({
            data: gDataUser,
            "columns": [
                { "data": gORDER[gCOLUMN_ORDER_CODE] },
                { "data": gORDER[gCOLUMN_KICHCO] },
                { "data": gORDER[gCOLUMN_LOAI_PIZZA] },
                { "data": gORDER[gCOLUMN_NUOCUONG] },
                { "data": gORDER[gCOLUMN_THANHTIEN] },
                { "data": gORDER[gCOLUMN_HOTEN] },
                { "data": gORDER[gCOLUMN_SDT] },
                { "data": gORDER[gCOLUMN_TRANG_THAI] },
                { "data": gORDER[gCOLUMN_ACTION] },
            ],
            "columnDefs": [
                {
                    "targets": gCOLUMN_ACTION,
                    "defaultContent": "<button id='btn-detail' class='btn btn-primary'>Chi tiết</button>"

                }]
        })
        /*** REGION 2 - Vùng gán / thực thi hàm xử lý sự kiện cho các elements */
        onPageLoading();
        // gán sự kiện nút chi tiết
        $("#order-table").on("click","#btn-detail" , function () {
            onBtnChiTietClick(this);
        })
        // gán sự kiện nút lọc
        $("#btn-filter-users").on("click", function(){
            onBtnFilterUser();
        })
        /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */

        function onPageLoading() {
            $.ajax({
                url: gBASE_URL,
                type: "GET",
                dataType: 'json',
                success: function (paramRes) {
                    gDataUser = paramRes
                    console.log(gDataUser);
                    loadDataToTable(gDataUser)
                },

                error: function (ajaxContent) {
                    alert(ajaxContent.responseText)
                }
            })
        }
        /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình */
        // hàm load dữ liêu bảng
        function loadDataToTable(paramDataTable) {
            "use strict"

            var vUserTable = $("#order-table").DataTable()
            vUserTable.clear();
            vUserTable.rows.add(paramDataTable)
            vUserTable.draw();
        }

        // hàm khi nút chi tiết được ấn
        function onBtnChiTietClick(paramChiTietButton) {
            console.log("Nút chi tiết được ấn")
            "use strict"
            var vUserTable = $("#order-table").DataTable();
            var vRowTable = $(paramChiTietButton).parents('tr');
            var vDateTableRow = vUserTable.row(vRowTable).data();

            console.log(vDateTableRow.id);
            console.log(vDateTableRow.orderCode);
            console.log(vDateTableRow.kichCo);
            console.log(vDateTableRow.loaiPizza);
            console.log(vDateTableRow.idLoaiNuocUong);
            console.log(vDateTableRow.thanhTien);
            console.log(vDateTableRow.hoTen);
            console.log(vDateTableRow.soDienThoai);
            console.log(vDateTableRow.trangThai);
        }
        // hàm nút lọc được ấn 
        function onBtnFilterUser(){
            "use strict"
            var vStatus = $("#sel-status").val();
            var vPizzaType =$("#sel-pizza").val();
             var vDataFilter = gDataUser.filter(function(paramOrder){
                return (vStatus === "all" || vStatus.toUpperCase() === paramOrder.trangThai.toUpperCase() )
                
                && (vPizzaType === "all" || vPizzaType.toUpperCase() === paramOrder.loaiPizza.toUpperCase())
             })
             loadDataToTable(vDataFilter)
        }
    })
</script>

</html>